<template>
  <div
      class="renderer"
       @click="onClick"
  >
    <keep-alive>
      <component
          :is="wrapper"
          class="renderer__body"
          v-html="html"
          ref="content"
      />
    </keep-alive>
  </div>
</template>

<style lang="scss">
.renderer {
  height: 100%;
  overflow: hidden;

  &__body {
    padding: 16px;
    overflow: auto;
    height: 100%;
    width: 100%;
  }
}
</style>

<script lang="ts">
import {defineComponent} from 'vue';

import light from '../components/ContentWrapperLight.vue';
import dark from '../components/ContentWrapperDark.vue';

export default defineComponent({
  components: {
    light,
    dark
  },

  props: {
    html: {
      type: String,
      default: ''
    }
  },

  data: () => ({
    wrapper: 'light',
  }),

  watch: {
    '$q.dark.isActive': {
      immediate: true,
      deep: true,
      handler(isActive) {
        this.wrapper = isActive
            ? 'dark'
            : 'light';
      }
    }
  },

  methods: {
    onClick (event: MouseEvent) {
      event.preventDefault();
      event.stopPropagation();
      const target = (event.target as HTMLLinkElement);

      if (target?.href) {
        const url = target.href.startsWith('http')
            ? target.href
            : `https://${target.href}`;

        window.runtime.BrowserOpenURL(url);
      }
    }
  }
});
</script>